package com.synnex.notification.servlet;

import java.io.IOException;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.juli.logging.Log;
import org.apache.juli.logging.LogFactory;

import com.synnex.notification.core.Config;
import com.synnex.notification.core.NotificationManager;
import com.synnex.notification.util.StringUtil;
import com.synnex.notification.vo.User;

@WebServlet(name="DeployServlet", urlPatterns={"/deploy.do"})
public class DeployServlet extends HttpServlet
{
	private static final long serialVersionUID = -7353077218783480889L;
	private static final Log log = LogFactory.getLog(DeployServlet.class);
	
	private final String PARAM_MESSAGE = "message";

	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException
	{
		String action = req.getParameter(Config.PARAM_ACTION);
		if("deploy".equals(action))
		{
			deployMessage(req, resp);
		}
		else
		{
			toDeployPage(req, resp);
		}
	}
	private void toDeployPage(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException
	{
		Set<User> userList = NotificationManager.getAllUser();
		req.setAttribute("userList", userList);
		req.getRequestDispatcher("deploy.jsp").forward(req, resp);
	}
	private void deployMessage(HttpServletRequest req, HttpServletResponse resp)
	{
		String msg = req.getParameter(PARAM_MESSAGE);
		String[] names = req.getParameterValues(Config.PARAM_USERNAME);
		if(names == null || names.length <= 0)
		{
			log.info("## no user selected ##");
			return;
		}
		if(StringUtil.isEmpty(msg))
		{
			log.info("## message is empty ##");
			return;
		}
		for(String username : names)
		{
			if(StringUtil.isEmpty(username))
			{
				continue;
			}
			User user = new User(username);
			NotificationManager.sendMessage(user, msg);
		}
		log.info("## send message completed ##");
	}
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException
	{
		this.doGet(req, resp);
	}
}