package com.synnex.notification.util;


/**
 *
 * @author Lance Chen
 */
public class StringUtil {

    private StringUtil() {
    }

    /**
     * Determine a string is an integer.
     * @param str The string
     * @return Return true if is integer
     */
    public static boolean isInteger(String str) {
        try {
            Integer.parseInt(str);
        } catch (Exception e) {
            return false;
        }
        return true;
    }
    
    public static boolean isLong(String str)
    {
    	try
		{
			Long.parseLong(str);
		} catch (Exception e)
		{
			return false;
		}
		return true;
    }

    /**
     * Determine a string is empty.
     * @param str The given string
     * @return Return true if is empty
     */
    public static boolean isEmpty(String str) {
        if (str == null || str.trim().length() <= 0 || "null".equals(str)) {
            return true;
        }
        return false;
    }
    
    public static boolean isEquals(String str1, String str2)
    {
    	if(str1 == str2)
    	{
    		return true;
    	}
    	str1 = (str1 == null) ? "" : str1;
    	str2 = (str2 == null) ? "" : str2;
    	return str1.equals(str2);
    }
    public static String firstCharUpper(String str)
    {
    	if(isEmpty(str))
    	{
    		return str;
    	}
    	return str = (str.charAt(0) + "").toUpperCase() + str.substring(1);
    }
    public static boolean isDouble(String str)
    {
    	if(isEmpty(str))
    	{
    		return false;
    	}
    	return str.matches("^[-]?[\\d]+[\\.]?[\\d]*$");
    }
    /**
     * Determine a string is email.
     * @param email The given string
     * @return Return true if is email
     */
    public static boolean isEmail(String email) {
        if (StringUtil.isEmpty(email)) {
            return false;
        }
        String regex = "^[\\w\\.\\-]+@([\\w\\-]+\\.)+[\\w\\-]+$";
        return email.matches(regex);
    }
}
